;Another Biobytes Tiny Game!
#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle2

hiscore:			;Lite86 II is cool
	.dw 0

ProgStart:
	call _runindicoff
	call _clrLCD
	call Gameloop2
	ld hl, deadstring
	ld de, $0503
	call drawstring
	ld hl, ShellTitle2
	ld de, 0
	call drawstring
	call highscoreroutine
	ld hl, (hiscore)
	ld de, $0f06
	call drawnumber
	ld hl, hiscorestring
	ld de, $0506
	call drawstring
	jp _pause

Gameloop2:
	call DrawTable
	ld de, (posx)
	ld hl, you
	call GridPutSprite
waittillpress
	call _getky
	or a
	jr z, waittillpress
	cp K_EXIT
	ret z
	cp K_SECOND
	jr z, hitsecond
	push af
	ld a, (makeseed)
	cp 1
	jr nz, nomakeseed
	ld hl, (posx)
	call gettablepos
	ld a, 2
	ld (hl), a
nomakeseed:
	ld a, 1
	ld (makeseed), a
	pop af
	ld hl, posy
	cp K_UP
	jr z, goleft
	cp K_DOWN
	jr z, godown
	ld hl, posx
	cp K_LEFT
	jr z, goleft
	cp K_RIGHT
	jr nz, Gameloop2
	ld a, (hl)
	cp 14
	jr z, backGameloop
	inc (hl)
	jr Gameloop
goleft:
	ld a, (hl)
	cp 1
	jr z, backGameloop
	dec (hl)
	jr Gameloop
godown:
	ld a, (hl)
	cp 6
	jr z, backGameloop
	inc (hl)
Gameloop:
	ld hl, (posx)
	call gettablepos
	ld a, (hl)
	cp 1
	call z, add10
	cp 2
	jr z, steppedonseed
	cp 3
	ret z
backsosoon:
	ld a, r						;make pits
	and %00000011
	ld b, 3
	call make4
	ld a, r
	and %00001100
	rra
	rra
	call make4
backgameloop:
	jp Gameloop2

hitsecond:
	ld de, 80					;buy out
	ld hl, (money)
	sbc hl, de
	jr c, backsosoon
	ld (money), hl
steppedonseed:					;put 4 dollars around you
	ld b, 4
stseedloop:
	push bc
	ld a, b
	ld b, 1
	dec a
	call make4
	pop bc
	djnz stseedloop
	xor a
	ld (makeseed), a
	ld b, a
	ld hl, (posx)
	call gettablepos
	ld (hl), b
	jr backgameloop

add10:
	ld de, 10
	ld hl, (score)
	add hl, de
	ld (score), hl
	ld hl, (money)
	add hl, de
	ld (money), hl
	ret
make4:
	ld de, posy
	or a
	jr z, makedown
	cp 1
	jr z, makeup
	dec de
	cp 2
	jr z, makeleft
	ld a, (de)
	cp 14
	ret z
	inc a
	jr finishleftright
makeleft:
	ld a, (de)
	cp 1
	ret z
	dec a
finishleftright:
	inc de
	ld l, a
	ld a, (de)
	ld h, a
finishmake4:
	call GetTablePos
	ld (hl), b
	ret
makeup:
	ld a, (de)
	cp 1
	ret z
	dec a
	jr finishupdown
makedown:
	ld a, (de)
	cp 6
	ret z
	inc a
finishupdown:
	ld h, a
	dec de
	ld a, (de)
	ld l, a
	jr finishmake4

GetTablePos:
	ld a, h
	add a, a
	add a, a
	add a, a
	add a, a
	add a, l
	ld de, Table
	ld l, a
	ld h, 0
	add hl, de
	ret

DrawTable:
	ld hl, Table
	ld de, 0
	ld b, 128
dtableloop:
	push bc
	push hl
	push de
	ld a, (hl)
	rlca
	rlca
	rlca
	ld c, a
	ld b, 0
	ld hl, Blank
	add hl, bc
	call GridPutSprite
	pop de
	inc e
	ld a, e
	cp 16
	call z, resetd
	pop hl
	inc hl
	pop bc
	djnz dtableloop
	ld hl, (money)
	ld de, $0500
	call drawnumber
	ld hl, (score)
	ld de, $0f07
	call drawnumber
	ld hl, scorestring
	ld de, $0a07
	call drawstring
	ld hl, moneystring
	ld de, $0000
	call drawstring
	ret
resetd:
	ld e, 0
	inc d
	ret

drawnumber:
	xor a
	ld (_CurRow), de
	jp _dispAHL
drawstring:
	ld (_CurRow), de
	jp _puts

GridPutSprite:
    push hl                ; push hl to stack...                
    pop ix                 ; ...and pop it into ix
    srl d                  ; de = (128 * y) + x
    rra                    ; carry flag -&lg; msb of a
    and $80                ; a is either $00 or $80   
    or e                   ; add x offset (remember x <= 15)
    ld e,a                 ; de = (128 * y) + (x * 8)
    ld hl,$fc00            ; hl-> video memory
    add hl,de              ; hl-> video memory + offset
    ld b,8                 ; initialize loop counter
    ld de,16               ; screen is 16 bytes wide
GPS_Loop:
    ld a,(ix + 0)          ; get byte from sprite
    ld (hl),a              ; put byte on screen
    inc ix                 ; move to next byte in sprite
    add hl,de              ; move to next line on screen
    djnz GPS_Loop          ; loop until sprite is drawn
    ret                    ; return

You:
	.db %00110000
	.db %00110000
	.db %00010000
	.db %00111000
	.db %01010100
	.db %01010100
	.db %00010000
	.db %00101000

Blank:
	.db 0,0,0,0,0,0,0,0

Dollar:
	.db %00000000
	.db %00101000
	.db %01111110
	.db %10101000
	.db %01111100
	.db %00101010
	.db %11111100
	.db %00101000

Seed:
	.db %00000000
	.db %00010000
	.db %00010000
	.db %00101000
	.db %01010100
	.db %01000100
	.db %00101000
	.db %00010000

Pit:
	.db %00000000
	.db %00111100
	.db %01111110
	.db %01111110
	.db %01111110
	.db %01111110
	.db %00111100
	.db %00000000

Border:
	.db %11101111
	.db %10101001
	.db %11101001
	.db %00001111
	.db %11110000
	.db %10010111
	.db %10010101
	.db %11110111

Table:
	.db 0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 4, 4, 4, 4, 4, 4
	.db 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4
	.db 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4
	.db 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4
	.db 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4
	.db 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4
	.db 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4
	.db 4, 4, 4, 4, 4, 4, 4, 0, 0, 0, 0, 0, 0, 0, 0, 4

highscoreroutine:
	ld hl, (score)
	ld de, (hiscore)
	ld a, d
	cp h
	jr c, highscoreset
	jr z, checksame
	ret 
checksame:
	ld a, e
	cp l
	ret nc
highscoreset
	ld (hiscore), hl
	push hl
	ld hl, name-1					
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _load_ram_ahl
	ld de,hiscore-$d744		;-$d744 = -$d748 (program counter) + 4 (header thingy)
	add hl,de
	pop de
	ld (hl), e
	inc hl
	ld (hl), d
	ret

hiscorestring
	.text "High Score:"
score:
	.dw 50
money:
	.dw 50
scorestring:
	.text "Score:"
moneystring:
	.text "Money:"
deadstring:
	.text "YOU ARE DEAD"
ShellTitle2:
	.db "By T. Williamson ",0
posx:
	.db 8
posy:
	.db 3
makeseed:
	.db 1
name:
	.db 7, "MDseeds"

.end
